`timescale 10ns/1ps

module testbench;
  reg signed [17:0]s; //input
  reg [3:0] k;  // time period
  reg signed [17:0] InitialOut; // initial condition
  wire signed [17:0] out; // output
  reg clk, reset; 
  integer logfile;  // file to store the data
  
  
   initial begin
     // store the data in a logfile, fopen is used to create a file
            logfile = $fopen("logfile.txt","w");
     
        //  if (!logfile)
        //  $display("Can't open \"logfile.txt\"");
        //  $finish;
        //   end    

           $timeformat(-9,1,"ns",5);
            InitialOut = 0;
            //s = 18'b00001_000000000000;
            //s = 18'b011111111111111111;
          // s = 18'b000000000000000011;
           // s = -18'b00001_000000000000;
            //s=2'b01; doesnt work!! dont bother trying this
            s = 18'b01111_1111111111111;
            k = 1; 
                
    //initial begin	 
	         clk = 1'b1;
          	reset = 0;
          #5 reset = 1;
 	        forever #1 clk = ~clk;
         //    end
  
  // initializing the input for the differential equation 
  
   // initial begin
  

  
             end
  
  // stimuli for the differential equation..
  
  difequ dtest(s,out,InitialOut,k,clk,reset);
  //difequ_integrate dtest(s,out,InitialOut,k,clk,reset);
 
  // $monitoron; // use this only if monitor is turned off
   
     always @ (posedge clk)
         #15  begin
              
           if (reset != 0)
              begin
              //   $fdisplay(logfiledetail,"At t = %t, out = %d",$realtime,out);
                  $fdisplay(logfile,out);
              end
            else
                begin
                //$fclose(logfiledetail);
                $fclose(logfile);
              end
                
   
          end

       always #15000 
         begin
            reset = 0;
            $fclose(logfile);
        end
  
  endmodule;
     
    
     
     
   
    
